aboutsummaryrefslogtreecommitdiffstats
path: root/coin/provisioning/common/DownloadURL.sh
diff options
context:
space:
mode:
authorOswald Buddenhagen <oswald.buddenhagen@qt.io>2017-01-18 10:47:04 +0100
committerOswald Buddenhagen <oswald.buddenhagen@qt.io>2017-01-18 10:49:22 +0100
commite74b0f7df4e6785dfd8660bbf60da6f2979225a3 (patch)
tree9316159f43e832b2acfd898867943c26c9070669 /coin/provisioning/common/DownloadURL.sh
parent63d77a0b28022d77bb20c59ea2ea57bdfc1ac5ed (diff)
parentb336c10c08bd7b053a49e06aaa725339d4fb4ea1 (diff)
Merge remote-tracking branch 'origin/5.8' into 5.8.0
This pulls in the CI build configurations. These files were previously stored in the CI source tree, but they do belong here. They describe the different configurations under which we want to build Qt and its submodules, in terms of underlying virtual machine template, host OS, target OS and CI related features that may also map to Qt configuration features. Task-number: QTQAINFRA-1074 Started-by: Simon Hausmann <simon.hausmann@qt.io> Change-Id: I8ab9b987a28566ad036dcaf8f0663bd633fea439
Diffstat (limited to 'coin/provisioning/common/DownloadURL.sh')
-rw-r--r--coin/provisioning/common/DownloadURL.sh85
1 files changed, 85 insertions, 0 deletions
diff --git a/coin/provisioning/common/DownloadURL.sh b/coin/provisioning/common/DownloadURL.sh
new file mode 100644
index 00000000..9bf7fdb7
--- /dev/null
+++ b/coin/provisioning/common/DownloadURL.sh
@@ -0,0 +1,85 @@
+#!/bin/bash
+
+#############################################################################
+##
+## Copyright (C) 2017 The Qt Company Ltd.
+## Contact: http://www.qt.io/licensing/
+##
+## This file is part of the test suite of the Qt Toolkit.
+##
+## $QT_BEGIN_LICENSE:LGPL21$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see http://www.qt.io/terms-conditions. For further
+## information use the contact form at http://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 2.1 or version 3 as published by the Free
+## Software Foundation and appearing in the file LICENSE.LGPLv21 and
+## LICENSE.LGPLv3 included in the packaging of this file. Please review the
+## following information to ensure the GNU Lesser General Public License
+## requirements will be met: https://www.gnu.org/licenses/lgpl.html and
+## http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
+##
+## As a special exception, The Qt Company gives you certain additional
+## rights. These rights are described in The Qt Company LGPL Exception
+## version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+
+# A helper script used for downloading a file from a URL or an alternative
+# URL. Also the SHA1 is checked for the file. Target filename should also
+# be given.
+#
+# If called directly from another script, it will exit the parent script
+# as well, if not called in its own subshell with parentheses.
+
+# shellcheck source=try_catch.sh
+source "${BASH_SOURCE%/*}/try_catch.sh"
+
+ExceptionDownloadPrimaryUrl=100
+ExceptionDownloadAltUrl=101
+ExceptionSHA1=102
+
+function DownloadURL {
+ url=$1
+ url_alt=$2
+ expectedSha1=$3
+ targetFile=$4
+
+ try
+ (
+ try
+ (
+ echo "Downloading from primary URL '$url'"
+ curl --fail -L --retry 5 --retry-delay 5 -o "$targetFile" "$url" || throw $ExceptionDownloadPrimaryUrl
+ )
+ catch || {
+ case $ex_code in
+ $ExceptionDownloadPrimaryUrl)
+ echo "Failed to download '$url' multiple times"
+ echo "Downloading tar.gz from alternative URL '$url_alt'"
+ curl --fail -L --retry 5 --retry-delay 5 -o "$targetFile" "$url_alt" || throw $ExceptionDownloadAltUrl
+ ;;
+ esac
+ }
+ echo "Checking SHA1 on PKG '$targetFile'"
+ echo "$expectedSha1 *$targetFile" | shasum --check || throw $ExceptionSHA1
+ )
+
+ catch || {
+ case $ex_code in
+ $ExceptionDownloadAltUrl)
+ echo "Failed downloading PKG from primary and alternative URLs"
+ exit 1;
+ ;;
+ esac
+ }
+}
+